VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Arpeggiator"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Description = "Arpeggiator Class - Top level"
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Attribute VB_Ext_KEY = "Member0" ,"NoteAry"
Attribute VB_Ext_KEY = "Member1" ,"NoteOffQ"
Attribute VB_Ext_KEY = "Member2" ,"NoteOnQ"
Attribute VB_Ext_KEY = "Member3" ,"PlayQ"
Option Explicit

'local variable(s) to hold property value(s)
Private mvarnow As Long 'local copy
Private mvartempo As Integer 'local copy
Private mvarresolution As Integer 'local copy
Private mvarsustain As Integer 'local copy
Private mvaroctaves As Integer 'local copy
Private mvarcycle As Integer 'local copy
Private mvarperiod As Integer 'local copy
Private mvarDuration As Integer 'local copy
Private mvarseqCount As Integer 'local copy
Private mvarNoteAry As NoteAry
Private mvarNoteOnQ As NoteOnQ
Private mvarNoteOffQ As NoteOffQ
Private mvarPlayQ As PlayQ
'local variable(s) to hold property value(s)
Private mvarShouldUpdate As Boolean 'local copy

Public mox As MIDIOXLib.MoxScript

Public Property Let ShouldUpdate(ByVal vData As Boolean)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.ShouldUpdate = 5
    mvarShouldUpdate = vData
End Property

Public Property Get ShouldUpdate() As Boolean
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.ShouldUpdate
    ShouldUpdate = mvarShouldUpdate
End Property

Public Property Get PlayQ() As PlayQ
   Set PlayQ = mvarPlayQ
End Property

Public Property Set PlayQ(vData As PlayQ)
   Set mvarPlayQ = vData
End Property

Public Property Get NoteOffQ() As NoteOffQ
   Set NoteOffQ = mvarNoteOffQ
End Property

Public Property Set NoteOffQ(vData As NoteOffQ)
   Set mvarNoteOffQ = vData
End Property

Public Property Get NoteOnQ() As NoteOnQ
   Set NoteOnQ = mvarNoteOnQ
End Property

Public Property Set NoteOnQ(vData As NoteOnQ)
   Set mvarNoteOnQ = vData
End Property

Private Sub Class_Initialize()
   'create the mNoteAry object when the Arpeggiator class is created
   Set mvarNoteAry = New NoteAry
  
   'create the mNoteOnQ object when the Arpeggiator class is created
   Set mvarNoteOnQ = New NoteOnQ
  
   'create the mNoteOffQ object when the Arpeggiator class is created
   Set mvarNoteOffQ = New NoteOffQ
  
   'create the mPlayQ object when the Arpeggiator class is created
   Set mvarPlayQ = New PlayQ
End Sub

Public Property Get NoteAry() As NoteAry
   Set NoteAry = mvarNoteAry
End Property

Public Property Set NoteAry(vData As NoteAry)
   Set mvarNoteAry = vData
End Property

Private Sub Class_Terminate()
   Set mvarPlayQ = Nothing
   Set mvarNoteOffQ = Nothing
   Set mvarNoteOnQ = Nothing
   Set mvarNoteAry = Nothing
   Set mox = Nothing
   
End Sub

Public Sub Init(ByVal lNow As Long, ByVal nTempo As Integer, ByVal nResolution As Integer, ByVal nSustain As Integer, ByVal nOctaves As Integer, ByVal nCycle As Integer)
   mvarnow = lNow
   
   UpdateParams nTempo, nResolution, nSustain, nOctaves, nCycle
   
   mvarseqCount = 0
   
End Sub

Public Function MaybeTrigger(ByVal lNow As Long) As Boolean
   Dim lNextTime As Long
   Dim evt As QEvt
   Dim trgEvt As NoteEvt
   Dim nPitch As Byte
   Dim ii As Integer
   Dim bTriggered As Boolean
   
   lNextTime = CLng(mvarperiod) * CLng(mvarseqCount)
   bTriggered = False
   
   ' Has a Note Off trigger expired?
   Set evt = mvarNoteOffQ.Peek
   If Not evt Is Nothing Then
      If evt.Trigger <= lNow Then
         Set trgEvt = FindEvt(evt.Index)
         If Not trgEvt Is Nothing Then
            If trgEvt.ID <> -1 Then
               nPitch = evt.CalcPitch(trgEvt.Note)
               NoteOff trgEvt.chan, nPitch
               For ii = mvarPlayQ.Count To 1 Step -1
                  If mvarPlayQ.Item(ii).Index = evt.Index Then
                     mvarPlayQ.Remove ii
                  End If
               Next ii
                       
               ' pull out of queue and add to end
               mvarNoteOffQ.Add evt.Index, evt.OctMult, evt.Trigger + lNextTime
               Set evt = mvarNoteOffQ.Pull
               bTriggered = True
            End If
         End If
      End If
   End If
  
   ' has a Note On trigger expired?
   Set evt = mvarNoteOnQ.Peek
   If Not evt Is Nothing Then
      If evt.Trigger <= lNow Then
         Set trgEvt = FindEvt(evt.Index)
         If Not trgEvt Is Nothing Then
            If trgEvt.ID <> -1 Then
               nPitch = evt.CalcPitch(trgEvt.Note)
               NoteOn trgEvt.chan, nPitch, trgEvt.Velocity
               mvarPlayQ.Add evt.Index, evt.OctMult, evt.Trigger
               mvarNoteOnQ.Add evt.Index, evt.OctMult, evt.Trigger + lNextTime
               Set evt = mvarNoteOnQ.Pull
               bTriggered = True
            End If
         End If
      End If
   End If
      
   MaybeTrigger = bTriggered
   
End Function

Public Sub FillRandom(ByVal lNow As Long)
   Dim lTrigger As Long
   Dim ii As Integer
   Dim jj As Integer
   Dim kk As Integer
   Dim nCount As Integer
   Dim Aryii(64) As Byte ' a deck to shuffle
   Dim Aryjj(64) As Byte ' a deck to shuffle
   Dim nCountkk As Integer
   Dim nSwap As Integer
   Dim nTemp As Integer
   
   lTrigger = lNow
   nCount = mvarNoteAry.Count
   
   kk = 0
   For ii = 1 To mvaroctaves
      For jj = 1 To nCount
         Aryii(kk) = ii
         Aryjj(kk) = jj
         kk = kk + 1
      Next jj
   Next ii
   
   
   For ii = 1 To mvaroctaves
      For jj = 1 To nCount
         If ii = mvaroctaves And jj = nCount Then
            GoTo NextJJ
         End If
         
         If ii = 1 And jj = 1 Then
            GoTo NextJJ
         End If
         
         Aryii(kk) = ii
         Aryjj(kk) = jj
         kk = kk + 1
NextJJ:
      Next jj
   Next ii

   ' Shuffle
   Randomize
   nCountkk = kk
   For kk = 0 To nCountkk - 1
      nSwap = CInt(CDbl(nCountkk - 1) * Rnd)
      nTemp = Aryii(kk)
      Aryii(kk) = Aryii(nSwap)
      Aryii(nSwap) = nTemp
      
      nTemp = Aryjj(kk)
      Aryjj(kk) = Aryjj(nSwap)
      Aryjj(nSwap) = nTemp
   Next kk
   
   ' Now build the data
   mvarseqCount = 0
   For kk = 0 To nCountkk - 1
      lTrigger = CreateRawEvts(Aryjj(kk), Aryii(kk), lTrigger)
      mvarseqCount = mvarseqCount + 1
   Next kk
   
End Sub

Public Sub FillDownUp(ByVal lNow As Long)
   Dim lTrigger As Long
   Dim ii As Integer
   Dim jj As Integer
   Dim nCount As Integer
   
   lTrigger = lNow
   nCount = mvarNoteAry.Count
   mvarseqCount = 0
   
   For ii = mvaroctaves To 1 Step -1
      For jj = nCount To 1 Step -1
         lTrigger = CreateRawEvts(jj, ii, lTrigger)
         mvarseqCount = mvarseqCount + 1
      Next jj
   Next ii
   
   For ii = 1 To mvaroctaves
      For jj = 1 To nCount
         If ii = mvaroctaves And jj = nCount Then
            GoTo NextJJ
         End If
         
         If ii = 1 And jj = 1 Then
            GoTo NextJJ
         End If
         
         lTrigger = CreateRawEvts(jj, ii, lTrigger)
         mvarseqCount = mvarseqCount + 1
NextJJ:
      Next jj
   Next ii
   
End Sub

Public Sub FillUpDown(ByVal lNow As Long)
   Dim lTrigger As Long
   Dim ii As Integer
   Dim jj As Integer
   Dim nCount As Integer
   
   lTrigger = lNow
   nCount = mvarNoteAry.Count
   mvarseqCount = 0
   
   For ii = 1 To mvaroctaves
      For jj = 1 To nCount
         lTrigger = CreateRawEvts(jj, ii, lTrigger)
         mvarseqCount = mvarseqCount + 1
      Next jj
   Next ii
   
   
   For ii = mvaroctaves To 1 Step -1
      For jj = nCount To 1 Step -1
         If ii = mvaroctaves And jj = nCount Then
            GoTo NextJJ
         End If
         
         If ii = 1 And jj = 1 Then
            GoTo NextJJ
         End If
         
         lTrigger = CreateRawEvts(jj, ii, lTrigger)
         mvarseqCount = mvarseqCount + 1
NextJJ:
      Next jj
   Next ii

End Sub

Public Sub FillDown(ByVal lNow As Long)
   Dim lTrigger As Long
   Dim ii As Integer
   Dim jj As Integer
   Dim nCount As Integer
   
   lTrigger = lNow
   nCount = mvarNoteAry.Count
   mvarseqCount = 0
   
   For ii = mvaroctaves To 1 Step -1
      For jj = nCount To 1 Step -1
         lTrigger = CreateRawEvts(jj, ii, lTrigger)
         mvarseqCount = mvarseqCount + 1
      Next jj
   Next ii
      
End Sub

Public Sub FillUp(ByVal lNow As Long)
   Dim lTrigger As Long
   Dim ii As Integer
   Dim jj As Integer
   Dim nCount As Integer
   
   lTrigger = lNow
   nCount = mvarNoteAry.Count
   mvarseqCount = 0
   
   For ii = 1 To mvaroctaves
      For jj = 1 To nCount
         lTrigger = CreateRawEvts(jj, ii, lTrigger)
         mvarseqCount = mvarseqCount + 1
      Next jj
   Next ii
      
End Sub

Public Function CreateRawEvts(ByVal nIndex As Integer, ByVal nOctave As Integer, ByVal lTrigTime As Long) As Long
   Dim lTrigOff As Long
   
   mvarNoteOnQ.Add nIndex, nOctave, lTrigTime
   lTrigOff = mvarNoteAry.Item(nIndex).Duration + lTrigTime
   mvarNoteOffQ.Add nIndex, nOctave, lTrigOff
   
   CreateRawEvts = lTrigTime + mvarperiod
   
End Function

Public Function FindEvt(ByVal nIndex As Integer) As NoteEvt
   Dim ii As Integer
   
   For ii = (nIndex + 1) To 1 Step -1
      If ii > mvarNoteAry.Count Then
         GoTo NextII
      End If
      
      If mvarNoteAry.Item(ii).ID = nIndex Then
         Set FindEvt = mvarNoteAry.Item(ii)
         Exit Function
      End If
NextII:
   Next ii
   
   Set FindEvt = Nothing
   
End Function

Public Sub NoteOn(ByVal nChan As Byte, ByVal nNote As Byte, ByVal nVeloc As Byte)
   Dim nStatus As Byte
   
   nStatus = &H90 Or nChan
   mox.OutputMidiMsg -1, nStatus, nNote, nVeloc
   
End Sub

Public Sub NoteOff(ByVal nChan As Byte, ByVal nNote As Byte)
   Dim nStatus As Byte
   
   nStatus = &H80 Or nChan
   mox.OutputMidiMsg -1, nStatus, nNote, 0

End Sub

Public Sub StopPlay()
   Dim evt As QEvt
   Dim ntEvt As NoteEvt
   
   Do While mvarPlayQ.Count > 0
      Set evt = mvarPlayQ.Pull
      If Not evt Is Nothing Then
         Set ntEvt = FindEvt(evt.Index)
         If Not ntEvt Is Nothing Then
            NoteOff ntEvt.chan, evt.CalcPitch(ntEvt.Note)
         End If
      End If
   Loop
      
End Sub

Public Sub RemoveAll()
   Dim ii As Integer
   Dim jj As Integer
   
   ' reverse order to ensure no missed evnts
   For ii = mvarNoteAry.Count To 1 Step -1
      mvarNoteAry.Remove ii
   Next ii
         
   For jj = mvarNoteOnQ.Count To 1 Step -1
      mvarNoteOnQ.Remove jj
   Next jj
            
   For jj = mvarNoteOffQ.Count To 1 Step -1
       mvarNoteOffQ.Remove jj
   Next jj
         
End Sub

Public Sub Remove(ByVal nChan As Byte, ByVal nNote As Byte)
   Dim nCount As Integer
   Dim ii As Integer
   Dim jj As Integer
   Dim nID As Integer
   
   ' reverse order to ensure no missed evnts
   nCount = mvarNoteAry.Count
   For ii = nCount To 1 Step -1
      If mvarNoteAry.Item(ii).Note = nNote And mvarNoteAry.Item(ii).chan = nChan Then
         nID = mvarNoteAry.Item(ii).ID
         For jj = mvarPlayQ.Count To 1 Step -1
            If mvarPlayQ.Item(jj).Index = nID Then
               NoteOff nChan, mvarPlayQ.Item(jj).CalcPitch(nNote)
               mvarPlayQ.Remove jj
            End If
         Next jj
         
         For jj = mvarNoteOnQ.Count To 1 Step -1
            If mvarNoteOnQ.Item(jj).Index = nID Then
               mvarNoteOnQ.Remove jj
            End If
         Next jj
            
         For jj = mvarNoteOffQ.Count To 1 Step -1
            If mvarNoteOffQ.Item(jj).Index = nID Then
               mvarNoteOffQ.Remove jj
            End If
         Next jj
         
         mvarNoteAry.Remove ii
      End If
   Next ii
         
End Sub

Public Sub Retrigger(ByVal lNow As Long)
   Dim nCount As Integer
   Dim ii As Integer
   Dim lTrigger As Long
      
   StopPlay
   
   ' resequence note ID's
   nCount = mvarNoteAry.Count
   For ii = 1 To nCount
      mvarNoteAry.Item(ii).ID = ii
      mvarNoteAry.Item(ii).Duration = mvarDuration
   Next ii
           
   For ii = mvarNoteOnQ.Count To 1 Step -1
      mvarNoteOnQ.Remove ii
   Next ii
                     
   For ii = mvarNoteOffQ.Count To 1 Step -1
      mvarNoteOffQ.Remove ii
   Next ii
         
   lTrigger = lNow + 5
   
   Select Case mvarcycle
      Case 1
         FillUp lTrigger
      Case 2
         FillDown lTrigger
      Case 3
         FillUpDown lTrigger
      Case 4
         FillDownUp lTrigger
      Case 5
         FillRandom lTrigger
   End Select
   
End Sub

Public Sub Add(ByVal lNow As Long, ByVal nChan As Byte, ByVal nNote As Byte, ByVal nVeloc As Byte)
   Dim Count As Integer
   Dim bInserted As Boolean
   Dim ii As Integer
   
   Count = mvarNoteAry.Count
   bInserted = False
   
   For ii = 1 To Count
      If nNote < mvarNoteAry.Item(ii).Note Then
         mvarNoteAry.Insert Count + 1, nChan, nNote, nVeloc, mvarDuration, Before:=ii
         bInserted = True
         Exit For
      End If
   Next ii
   
   If bInserted <> True Then
      ' add to end
      mvarNoteAry.Add Count + 1, nChan, nNote, nVeloc, mvarDuration
   End If
      
   Retrigger lNow
            
End Sub

Public Sub UpdateParams(ByVal nTempo As Integer, ByVal nResolution As Integer, ByVal nSustain As Integer, ByVal nOctaves As Integer, ByVal nCycle As Integer)
   mvartempo = nTempo
   mvarresolution = nResolution
   mvarsustain = nSustain
   mvaroctaves = nOctaves
   mvarcycle = nCycle
   
   mvarperiod = CalcPeriod(nTempo, nResolution)
   mvarDuration = CalcDuration(mvarperiod, nSustain)
End Sub

Public Function IsEmpty() As Boolean
  IsEmpty = (NoteAry.Count = 0)
End Function

Public Function CalcDuration(ByVal length As Integer, ByVal susCode As Integer) As Integer
   ' susCode is 1=stacatto, 2=normal 3=legato
   ' reduce by a couple of milliseconds
   CalcDuration = CInt(CLng(length) * susCode / 3) - 2
End Function

Public Function CalcPeriod(ByVal bpm As Integer, ByVal nBeats As Integer) As Integer
   ' 60 sec/min * 1000 msec/sec / bpm * (beats / 8 [Qtr note = 8 in combo])
   ' 60 * 1000 / 8 = 7500
   CalcPeriod = CInt((CLng(nBeats) * 7500) / CLng(bpm))
End Function

Public Property Let seqCount(ByVal vData As Integer)
   'used when assigning a value to the property, on the left side of an assignment.
   'Syntax: X.seqCount = 5
   mvarseqCount = vData
End Property

Public Property Get seqCount() As Integer
   'used when retrieving value of a property, on the right side of an assignment.
   'Syntax: Debug.Print X.seqCount
   seqCount = mvarseqCount
End Property

Public Property Let Duration(ByVal vData As Integer)
   'used when assigning a value to the property, on the left side of an assignment.
   'Syntax: X.duration = 5
   mvarDuration = vData
End Property

Public Property Get Duration() As Integer
   'used when retrieving value of a property, on the right side of an assignment.
   'Syntax: Debug.Print X.duration
   Duration = mvarDuration
End Property

Public Property Let period(ByVal vData As Integer)
   'used when assigning a value to the property, on the left side of an assignment.
   'Syntax: X.period = 5
   mvarperiod = vData
End Property

Public Property Get period() As Integer
   'used when retrieving value of a property, on the right side of an assignment.
   'Syntax: Debug.Print X.period
   period = mvarperiod
End Property

Public Property Let Cycle(ByVal vData As Integer)
   'used when assigning a value to the property, on the left side of an assignment.
   'Syntax: X.cycle = 5
   mvarcycle = vData
End Property

Public Property Get Cycle() As Integer
   'used when retrieving value of a property, on the right side of an assignment.
   'Syntax: Debug.Print X.cycle
   Cycle = mvarcycle
End Property

Public Property Let Octaves(ByVal vData As Integer)
   'used when assigning a value to the property, on the left side of an assignment.
   'Syntax: X.octaves = 5
   mvaroctaves = vData
End Property


Public Property Get Octaves() As Integer
   'used when retrieving value of a property, on the right side of an assignment.
   'Syntax: Debug.Print X.octaves
   Octaves = mvaroctaves
End Property

Public Property Let Sustain(ByVal vData As Integer)
   'used when assigning a value to the property, on the left side of an assignment.
   'Syntax: X.sustain = 5
   mvarsustain = vData
   mvarperiod = CalcPeriod(mvartempo, mvarresolution)
   mvarDuration = CalcDuration(mvarperiod, mvarsustain)
End Property

Public Property Get Sustain() As Integer
   'used when retrieving value of a property, on the right side of an assignment.
   'Syntax: Debug.Print X.sustain
   Sustain = mvarsustain
End Property

Public Property Let Resolution(ByVal vData As Integer)
   'used when assigning a value to the property, on the left side of an assignment.
   'Syntax: X.resolution = 5
   mvarresolution = vData
   mvarperiod = CalcPeriod(mvartempo, mvarresolution)
   mvarDuration = CalcDuration(mvarperiod, mvarsustain)
End Property

Public Property Get Resolution() As Integer
   'used when retrieving value of a property, on the right side of an assignment.
   'Syntax: Debug.Print X.resolution
   Resolution = mvarresolution
End Property

Public Property Let Tempo(ByVal vData As Integer)
   'used when assigning a value to the property, on the left side of an assignment.
   'Syntax: X.tempo = 5
   mvartempo = vData
   mvarperiod = CalcPeriod(mvartempo, mvarresolution)
   mvarDuration = CalcDuration(mvarperiod, mvarsustain)
End Property

Public Property Get Tempo() As Integer
   'used when retrieving value of a property, on the right side of an assignment.
   'Syntax: Debug.Print X.tempo
   Tempo = mvartempo
End Property

Public Property Let now(ByVal vData As Long)
   'used when assigning a value to the property, on the left side of an assignment.
   'Syntax: X.now = 5
   mvarnow = vData
End Property

Public Property Get now() As Long
   'used when retrieving value of a property, on the right side of an assignment.
   'Syntax: Debug.Print X.now
   now = mvarnow
End Property



