VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "MIDI-OX Arpeggiator"
   ClientHeight    =   2505
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4650
   Icon            =   "MOXArp.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2505
   ScaleWidth      =   4650
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox Retrigger 
      Caption         =   "Retri&gger new Data"
      Height          =   255
      Left            =   2040
      TabIndex        =   8
      Top             =   60
      Width           =   1755
   End
   Begin VB.CheckBox Divert 
      Caption         =   "&Divert Input"
      Height          =   255
      Left            =   180
      TabIndex        =   0
      Top             =   60
      Width           =   1575
   End
   Begin VB.Timer Timer 
      Enabled         =   0   'False
      Interval        =   1000
      Left            =   120
      Top             =   1440
   End
   Begin VB.CheckBox CloseOnExit 
      Caption         =   "Close &MIDI-OX after Exit"
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   2040
      Width           =   2055
   End
   Begin VB.CheckBox Enable 
      Caption         =   "&Arpeggiate"
      Height          =   375
      Left            =   660
      Style           =   1  'Graphical
      TabIndex        =   6
      Top             =   1500
      Width           =   1155
   End
   Begin VB.TextBox Tempo 
      Height          =   315
      Left            =   960
      TabIndex        =   2
      Text            =   "120"
      Top             =   480
      Width           =   615
   End
   Begin VB.VScrollBar VScrollTempo 
      Height          =   315
      Left            =   1560
      Max             =   8
      Min             =   240
      TabIndex        =   3
      Top             =   480
      Value           =   8
      Width           =   255
   End
   Begin VB.ComboBox Resolution 
      Height          =   315
      ItemData        =   "MOXArp.frx":0CFA
      Left            =   3000
      List            =   "MOXArp.frx":0D12
      Style           =   2  'Dropdown List
      TabIndex        =   10
      Top             =   480
      Width           =   1395
   End
   Begin VB.ComboBox Octaves 
      Height          =   315
      ItemData        =   "MOXArp.frx":0D3D
      Left            =   960
      List            =   "MOXArp.frx":0D4A
      Style           =   2  'Dropdown List
      TabIndex        =   5
      Top             =   1020
      Width           =   855
   End
   Begin VB.ComboBox Sustain 
      Height          =   315
      ItemData        =   "MOXArp.frx":0D57
      Left            =   3000
      List            =   "MOXArp.frx":0D64
      Style           =   2  'Dropdown List
      TabIndex        =   12
      Top             =   1020
      Width           =   1395
   End
   Begin VB.ComboBox Cycle 
      Height          =   315
      ItemData        =   "MOXArp.frx":0D83
      Left            =   3000
      List            =   "MOXArp.frx":0D96
      Style           =   2  'Dropdown List
      TabIndex        =   14
      Top             =   1560
      Width           =   1395
   End
   Begin VB.Label Status 
      AutoSize        =   -1  'True
      Caption         =   "MIDI-OX: 1 Ver: 6.4.0.270"
      Height          =   195
      Left            =   2460
      TabIndex        =   15
      Top             =   2070
      Width           =   1905
   End
   Begin VB.Label Label5 
      Caption         =   "&Cycle:"
      Height          =   255
      Left            =   2100
      TabIndex        =   13
      Top             =   1590
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "&Tempo:"
      Height          =   255
      Left            =   180
      TabIndex        =   1
      Top             =   510
      Width           =   615
   End
   Begin VB.Label Label2 
      Caption         =   "&Resolution:"
      Height          =   255
      Left            =   2040
      TabIndex        =   9
      Top             =   510
      Width           =   855
   End
   Begin VB.Label Label4 
      Caption         =   "&Octaves:"
      Height          =   255
      Left            =   180
      TabIndex        =   4
      Top             =   1080
      Width           =   735
   End
   Begin VB.Label Label3 
      Caption         =   "&Sustain:"
      Height          =   255
      Left            =   2100
      TabIndex        =   11
      Top             =   1050
      Width           =   855
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim glAddend As Long
Dim glNextUpd As Long

Dim WithEvents mox As MIDIOXLib.MoxScript
Attribute mox.VB_VarHelpID = -1
Dim arp As Arpeggiator
Dim InQ As InputQ

' Retain the last updated state
Dim octIx As Integer
Dim resIx As Integer
Dim susIx As Integer
Dim cycIx As Integer
Dim nTempo As Integer

Private Sub CloseOnExit_Click()
   mox.ShutdownAtEnd = CloseOnExit.Value
End Sub

Private Sub Divert_Click()
   If mox.FireMidiInput = 1 Then
      mox.DivertMidiInput = Divert.Value
   End If
End Sub

Private Sub Enable_Click()
   If Enable.Value = 1 Then
      ' it was off before
      mox.DivertMidiInput = Divert.Value
      mox.FireMidiInput = 1
      Timer.Interval = 10
      Timer.Enabled = True
   Else
      ' It was on: turn off
      Timer.Enabled = False
      mox.FireMidiInput = 0
      mox.DivertMidiInput = 0
      arp.StopPlay
      arp.RemoveAll
   End If
End Sub

Private Sub Form_Load()
   Dim n As Long
   Dim nInst As Long
   Dim str As String
   Dim val As Variant
   Dim sKeyName As String
   
   sKeyName = "Software\MIDI-OX\MOXArp"

   Set mox = New MIDIOXLib.MoxScript

   ' in util.bas
   glAddend = -1
   glNextUpd = mox.GetSystemTime + 500
   
   If QueryValue(sKeyName, "Tempo", val) <> 0 Then
      val = 120 'default
   End If
   Tempo = val
   VScrollTempo.Value = Tempo
   
   If QueryValue(sKeyName, "Octaves", val) <> 0 Then
      val = 1 'default
   End If
   Octaves.Text = val
   
   If QueryValue(sKeyName, "Resolution", val) <> 0 Then
      val = "Quarter" 'default
   End If
   Resolution.Text = val
   
   If QueryValue(sKeyName, "Sustain", val) <> 0 Then
      val = "Normal" 'default
   End If
   Sustain.Text = val
     
   If QueryValue(sKeyName, "Cycle", val) <> 0 Then
      val = "Up-Down" 'default
   End If
   Cycle.Text = val
     
   'now, tempo, resolution, sustain, octaves, cycle
   octIx = Octaves.ListIndex
   resIx = Resolution.ListIndex
   susIx = Sustain.ListIndex
   cycIx = Cycle.ListIndex
   nTempo = Tempo

   If QueryValue(sKeyName, "Divert", val) <> 0 Then
      val = 0 'default
   End If
   Divert.Value = val

   If QueryValue(sKeyName, "CloseOnExit", val) <> 0 Then
      val = 0 'default
   End If
   CloseOnExit.Value = val
   
   If QueryValue(sKeyName, "Retrigger", val) <> 0 Then
      val = 0 'default
   End If
   Retrigger.Value = val
   
   Status.Caption = "MIDI-OX:" & mox.InstanceNumber & " Ver: " & mox.GetAppVersion
   
   Set InQ = New InputQ
   Set arp = New Arpeggiator
   Set arp.mox = mox
   arp.Init mox.GetSystemTime, Tempo, Resolution.ItemData(Resolution.ListIndex), Sustain.ItemData(Sustain.ListIndex), Octaves.ItemData(Octaves.ListIndex), Cycle.ItemData(Cycle.ListIndex)
      
End Sub

Private Sub Form_Unload(Cancel As Integer)
   Dim sKeyName As String
   Dim val As Variant
   Dim lresult As Long
   
   sKeyName = "Software\MIDI-OX\MOXArp"

   ' ensure arpegiator is stopped
   If Enable.Value = 1 Then
      Enable.Value = 0
      Cancel = 1
      Exit Sub
   End If
   
   ' Remember Variable states
   
   val = Tempo
   If SetKeyValue(sKeyName, "Tempo", val, REG_DWORD) <> 0 Then
      MsgBox "SetKeyValue Tempo Failed"
   End If
   
   val = Octaves.Text
   If SetKeyValue(sKeyName, "Octaves", val, REG_SZ) <> 0 Then
      MsgBox "SetKeyValue Octaves Failed"
   End If
   
   val = Resolution.Text
   If SetKeyValue(sKeyName, "Resolution", val, REG_SZ) <> 0 Then
      MsgBox "SetKeyValue Resolution Failed"
   End If
   
   val = Sustain.Text
   If SetKeyValue(sKeyName, "Sustain", val, REG_SZ) <> 0 Then
      MsgBox "SetKeyValue Sustain Failed"
   End If
     
   val = Cycle.Text
   If SetKeyValue(sKeyName, "Cycle", val, REG_SZ) <> 0 Then
      MsgBox "SetKeyValue Cycle Failed"
   End If
  
   val = Divert.Value
   If SetKeyValue(sKeyName, "Divert", val, REG_DWORD) <> 0 Then
      MsgBox "SetKeyValue Divert Failed"
   End If

   val = CloseOnExit.Value
   If SetKeyValue(sKeyName, "CloseOnExit", val, REG_DWORD) <> 0 Then
      MsgBox "SetKeyValue CloseOnExit Failed"
   End If

   val = Retrigger.Value
   If SetKeyValue(sKeyName, "Retrigger", val, REG_DWORD) <> 0 Then
      MsgBox "SetKeyValue Retrigger Failed"
   End If
  
   Set arp = Nothing
   Set InQ = Nothing
   Set mox = Nothing
   
End Sub

Private Sub mox_MidiInput(ByVal nTimestamp As Long, ByVal Port As Long, ByVal Status As Long, ByVal data1 As Long, ByVal data2 As Long)
   
   If InterlockedIncrement(glAddend) > 0 Then
      ' we're busy
      InQ.Add mox.GetSystemTime, Status, data1, data2
      InterlockedDecrement glAddend
      Exit Sub
   End If
      
   ProcessEvent mox.GetSystemTime, Status, data1, data2
         
   InterlockedDecrement glAddend
      
End Sub

Private Sub ProcessEvent(ByVal lNow As Long, ByVal Status As Long, ByVal data1 As Long, ByVal data2 As Long)
   Dim chan As Byte
   Dim statRaw As Byte

   statRaw = Status And &HF0
   chan = Status And &HF
   If statRaw = &H90 Then
      ' Note on
      If data2 > 0 Then
         ' Note On
         arp.Add lNow, chan, data1, data2
         If Retrigger.Value = 1 Then
            arp.Retrigger lNow
         End If
      Else
         ' Note off
         statRaw = &H80
      End If
      
   End If
 
   If statRaw = &H80 Then
      ' We know this is a note off
      arp.Remove chan, data1
   Else
      If statRaw <> &H90 Then
         If mox.DivertMidiInput = 1 Then
           mox.OutputMidiMsg -1, Status, data1, data2
         End If
      End If
   End If
      
   ' arp.MaybeTrigger lNow

End Sub

Private Sub mox_OnTerminateMidiInput()
   mox.FireMidiInput = 0
   mox.DivertMidiInput = 0
End Sub

Private Sub Tempo_Validate(Cancel As Boolean)
   If Tempo < 8 Or Tempo > 240 Then
      MsgBox "Value must be between 8 and 240"
      Cancel = True
   Else
      VScrollTempo.Value = Tempo
      Cancel = False
   End If

End Sub

Private Sub Timer_Timer()
   Dim lNow As Long
   Dim evt As InQEvt
   Dim bTriggered As Boolean
   
   ' Kill off the timer -- we don't exit until the Arpegiate button pops
   Timer.Enabled = False
   
   lNow = mox.GetSystemTime
   
   Do
      If InterlockedIncrement(glAddend) > 0 Then
         ' we're busy
         InterlockedDecrement glAddend
         DoEvents
         mox.Sleep 5
         GoTo TryAgain
      End If
   
      Do While InQ.IsEmpty = False
         ' we've got some input to handle
         Set evt = InQ.Pull
         If Not evt Is Nothing Then
            ProcessEvent evt.lTime, evt.Status, evt.data1, evt.data2
         End If
      Loop
     
      ' Do the major timer work
      lNow = mox.GetSystemTime
      bTriggered = False
      If arp.IsEmpty = False Then
         bTriggered = arp.MaybeTrigger(lNow)
      End If
   
      InterlockedDecrement glAddend
   
      If Not bTriggered Then
         DoEvents
      End If
      
TryAgain:
      If Enable.Value = 1 Then
         lNow = mox.GetSystemTime

         ' Update dialog controls every 1/2 second if needed
         If glNextUpd < lNow Then
            glNextUpd = lNow + 500
            UpdControls
         End If
      End If
      
   Loop While Enable.Value = 1
   
End Sub

Private Sub UpdControls()
   Dim bUpd As Boolean
   
   bUpd = False
   
   ' Octave
   If Octaves.ListIndex <> -1 And Octaves.ListIndex <> octIx Then
      octIx = Octaves.ListIndex
      arp.Octaves = Octaves.ItemData(octIx)
      bUpd = True
   End If
      
   ' Resolution
   If Resolution.ListIndex <> -1 And Resolution.ListIndex <> resIx Then
      resIx = Resolution.ListIndex
      arp.Resolution = Resolution.ItemData(resIx)
      bUpd = True
   End If

   ' Sustain
   If Sustain.ListIndex <> -1 And Sustain.ListIndex <> susIx Then
      susIx = Sustain.ListIndex
      arp.Sustain = Sustain.ItemData(susIx)
      bUpd = True
   End If

   ' Cycle
   If Cycle.ListIndex <> -1 And Cycle.ListIndex <> cycIx Then
      cycIx = Cycle.ListIndex
      arp.Cycle = Cycle.ItemData(cycIx)
      bUpd = True
   End If

   ' Tempo
   If nTempo <> Tempo Then
      nTempo = Tempo
      arp.Tempo = nTempo
      bUpd = True
   End If
   
   If bUpd = True And Enable.Value = 1 Then
      arp.Retrigger mox.GetSystemTime
   End If

End Sub
Private Sub VScrollTempo_Change()
   Tempo = VScrollTempo.Value
End Sub

